package cz.moneta.test.regression.channels.digital.ib.newib.savings.fon;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.newib.tasks.NewIbTasks;
import cz.moneta.test.harness.annotations.Environment;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenarioWithOrder;
import cz.moneta.test.harness.support.auth.Credentials;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Order;

@TestScenarioWithOrder(name = "DPS tests")
public class DpsTest {

    Credentials clientCredentials;
    String clientId;

    @BeforeAll
    public void getCredentials(Harness harness) {
        String clientBirthNumber = harness.getConfig("nib.rc.dps.fon");

        clientCredentials = harness.tasks()
                .udebs()
                .findCredentialsByRC(clientBirthNumber);

        clientId = harness.withUdebs()
                .usersTable()
                .getClientId(clientBirthNumber);
    }

    @Order(1)
    @TestCase(name = "DPS - displayed on the dashboard and in the savings section", environments = {Environment.TST1, Environment.PPE})
    @JiraTestCase(id = "SB-T9295")
    public void dpsDisplayedOntheDashboardAndInTheSavingsSection(Harness harness) {
        NewIbTasks newIbTasks = harness.tasks().newIb();
        harness.withNewIb()
                .openLoginPage()
                .then(newIbTasks.loginWithUsernamePasswordAndDefaultMobKey(clientCredentials.getUsername(), clientCredentials.getPassword()))
                .then(newIbTasks.dpsDisplayedOntheDashboardAndInTheSavingsSection());
    }

    @Order(2)
    @TestCase(name = "DPS - change of contribution and deposit", environments = {Environment.TST1, Environment.PPE})
    @JiraTestCase(id = "SB-T9551")
    public void dpsChangeOfContributionAndDeposit(Harness harness) {
        NewIbTasks newIbTasks = harness.tasks().newIb();
        harness.withNewIb()
                .openLoginPage()
                .then(newIbTasks.loginWithUsernamePasswordAndDefaultMobKey(clientCredentials.getUsername(), clientCredentials.getPassword()))
                .then(newIbTasks.dpsChangeOfContributionAndDeposit());
    }
}